#!/bin/bash
###name:域名延时测试
###info:返回给定域名列表最小延时域名
###filename:k_domain.sh
#Server域名或IP地址，中括号一个数字代表一个域名，递增方式；
#例：server[0]="www.baidu.com"	server[1]="www.mxin.moe"
server[0]="www.baidu.com"
server[1]="www.mxin.moe"
server[2]="www.qq.com"
server[3]="www.sina.com"

curl --insecure https://api.mxin.moe/api/pv.php?shell=k_domain
source /etc/os-release
case $ID in
	debian|ubuntu)
		sudo apt -y install bc > /dev/null 2>&1
	;;
	centos)
		sudo yum -y install bc > /dev/null 2>&1
	;;
	*)
		echo '此脚本不支持此操作系统'
		exit
	;;
esac

i=0
while(($i<${#server[*]}))
do
	ii=0
	while(($ii<4))
	do
		r[$ii]=`ping ${server[0]} -c 1 -W 2 | awk '{print $8}' | awk -F= '{print $2}'`
		let ii++
	done
	result[$i]=`echo "scale=2; ("${r[0]} + ${r[1]} + ${r[2]} + ${r[3]}") / 4" | bc`
	result[$i]=${result[$i]}_${server[$i]}
	let i++
done
new=`echo ${result[*]} | tr ' ' '\n' | sort -n`
new=`echo ${new[*]} | awk '{print $1}' | awk -F_ '{print $2}'`
echo $new #此变量为返回的最快域名